image: node:12.20.0

stages:
  - package
  - deploy

package app:
  stage: package
  cache:
    key: app-package
    policy: push
    paths:
      - ./build
  artifacts:
    name: "$CI_JOB_NAME-$CI_COMMIT_REF_NAME"
    when: always
    expire_in: 2h30min
    paths:
      - ./build
  script:
    - yarn
    - yarn build
  after_script:
    - ls

deploy to staging:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest # see the note below
  cache:
    key: app-package
    policy: pull
  script:
    - ls
    - aws s3 cp ./build s3://$AWS_S3_STAGING --recursive --acl public-read
  environment:
    name: staging
    url: http://$AWS_S3_STAGING.s3-website-us-east-1.amazonaws.com
  only:
    - develop

deploy to production:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest # see the note below
  cache:
    key: app-package
    policy: pull
  script:
    - ls
    - aws s3 cp ./build s3://$AWS_S3_PRODUCTION --recursive --acl public-read
  environment:
    name: production
    url: http://$AWS_S3_PRODUCTION.s3-website-us-east-1.amazonaws.com
  only:
    - master
